package ca.mcgill.sable.ft.reccache.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Target;

/**
 * This annotation converts a method into a recoverable block.
 * Whenever the execution of an annotated method exits throwing an exception,
 * the global system state will automatically be restored to the state
 * that was valid before entring the method execution.
 *
 * @author Eric Bodden
 */
@Target(ElementType.METHOD)
public @interface Recoverable {

}
