import ca.mcgill.sable.ft.reccache.annotation.Recoverable;
import ca.mcgill.sable.ft.reccache.cache.Checkpoints;

/**
 * Main
 *
 * @author Eric Bodden
 */
public class Main {

	static int x;
	static int y;
	
	public static void main(String[] args) {

		//check "manual" checkpointing
		
		x=10;
		y=20;
		Checkpoints.establish();
		x=30;
		Checkpoints.establish();		
		y=40;
		x=50;
		System.out.println(x);
		System.out.println(y);
		Checkpoints.discard();
		System.out.println(x);
		System.out.println(y);
		Checkpoints.restore();
		System.out.println(x);
		System.out.println(y);
		
		//check recoverable blocks
		try {
			doSomething();
		} catch(RuntimeException e) {
			//swallow
		}
	}
	
	@Recoverable
	private static void doSomething() {
		System.err.println("-> x=30");
		x=30;

		try{
			doSomethingElse();
			System.err.println("<- x=30");
		} finally {
			System.err.println("x is now = "+ x);
		}
		
	}
	
	@Recoverable
	private static void doSomethingElse() {
		System.err.println("-> y=40,x=50");
		y=40;
		x=50;
		throw new RuntimeException();
//		System.err.println("<- y=40,x=50");
	}

}
